package com.sun.portal.pom;

import java.io.Serializable;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;

@IdClass(com.sun.portal.pom.EntityId.class)
@javax.persistence.Entity
@Inheritance(strategy=InheritanceType.JOINED)
public abstract class Entity implements Serializable {
    @Id
    @Column(nullable = false, name="ENTITY_NAME")
    @XmlAttribute
    private String name;
    
    @Id
    @Column(nullable = false, name="PAGE_ID")    
    @XmlTransient
    private String pageId = null;
    
    @ManyToOne(cascade=CascadeType.ALL, optional = false)
    @JoinColumn(insertable=false, updatable=false, nullable=false, name="PAGE_ID", referencedColumnName="PAGE_NAME")
    @XmlTransient
    private Page page = null;
    
    @Column(nullable = false)
    @XmlElement(name = "portlet-name")
    private String portletName;    
    
    public String getPortletName() {
        return portletName;
    }
    
    public void setPortletName(String portletName) {
        this.portletName = portletName;
    }
    
    public abstract String getPortletType();
    
    public abstract List<Preference> getPreferences();
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getPageId() {
        return pageId;
    }
    
    public Page getPage() {
        return page;
    }
    
    public void setPage(Page page) {
        this.page = page;
        this.pageId = new PageId(page).toString();
    }
    
    public EntityId getEntityId() {
        return new EntityId(this);
    }
    
    public String toString() {
        return "{ name=" + name + ", pageId=" + pageId + ", portletName=" + portletName + ", preferences=" + getPreferences() + " }";
    }
}
