package com.sun.portal.pom;

import java.io.Serializable;
import javax.xml.bind.annotation.XmlTransient;

@XmlTransient
public class EntityId implements Serializable {
    private String name;
    private String pageId;
    
    public EntityId() { }
    
    public EntityId(Entity e) {
        this.name = e.getName();
        this.pageId = new PageId(e.getPage()).toString();
    }

    public EntityId(String pageId, String name) {
        this.name = name;
        this.pageId = pageId;
    }
    
    public boolean equals(Object o) {
        EntityId other = (EntityId)o;
        
        if (!getName().equals(other.getName())) {
            return false;
        }
        
        if (!getPageId().equals(other.getPageId())) {
            return false;
        }
        
        return true;
    }
    
    public int hashCode() {
        return toString().hashCode();
    }
    
    public String toString() {
        String s = getPageId() + ":" + getName();        
        return s;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getPageId() {
        return pageId;
    }
    
    public void setPageId(String pageId) {
        this.pageId = pageId;
    }
}
