package com.sun.portal.pom;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.OneToMany;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;

@javax.persistence.Entity
public class PortletEntity extends Entity implements Serializable {
    @OneToMany(
        cascade = CascadeType.ALL,
        mappedBy = "entity"
    )    
    @XmlElement (
        name = "preference"
    )     
    private List<Preference> preferences = new ArrayList<Preference>();
    
    @Column (
        nullable = false
    )
    @XmlAttribute (
        name = "type"
    )
    private String portletType;
         
    public String getPortletType() {
        return portletType;
    }

    public void setPortletType(String portletType) {
        this.portletType = portletType;
    }
    
    public boolean equals(Object other) {
        if (!(other instanceof PortletEntity)) {
            return false;
        }

        return super.equals(other);
    }

    public List<Preference> getPreferences() {
        return preferences;
    }

    public void setPreferences(List<Preference> preferences) {
        this.preferences = preferences;
    }

    void beforeUnmarshal(Unmarshaller u, Object parent) {
       setPage((Page)parent);
   }
}
