package com.sun.portal.pom;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;

@IdClass(com.sun.portal.pom.PreferenceId.class)
@javax.persistence.Entity
public class Preference implements Serializable {
    @Id
    @Column(name="PREFERENCE_NAME", nullable=false)
    @XmlElement(name="name")
    private String name;
    
    @Id
    @Column(nullable = false, name="ENTITY_ID")
    @XmlTransient
    private String entityId = null;
    
    @ManyToOne(optional = false, cascade = CascadeType.ALL)
    @JoinColumns({
        @JoinColumn(insertable=false, updatable=false, nullable=false, name="ENTITY_ID", referencedColumnName="ENTITY_NAME"),
        @JoinColumn(insertable=false, updatable=false, nullable=false, name="PREFERENCE_NAME", referencedColumnName="PREFERENCE_NAME")
    })
    @XmlTransient
    private Entity entity;
    
    @Column(name="PREFERENCE_VALUES", nullable=false)
    @XmlElement(name="value")
    private ArrayList<String> values = new ArrayList<String>();
    
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public List<String> getValues() {
        return values;
    }
    
    public void setValues(ArrayList<String> values) {
        this.values = values;
    }
    
    public Entity getEntity() {
        return entity;
    }
    
    public void setEntity(Entity entity) {
        this.entity = entity;
        this.entityId = new EntityId(entity).toString();
    }
    
    public String getEntityId() {
        return entityId;
    }
    
    public PreferenceId getPreferenceId() {
        return new PreferenceId(this);
    }
    
    public String toString() {
        return "{ name=" + name + ", entityId=" + entityId + ", values=" + values + " }";
    }
    
    public void beforeUnmarshal(Unmarshaller u, Object parent) {
        setEntity((Entity)parent);
    }
    
}
