package com.sun.portal.pom;

import java.io.Serializable;
import javax.xml.bind.annotation.XmlTransient;

@XmlTransient
public class PreferenceId implements Serializable {
    private String name;
    private String entityId;    
    
    public PreferenceId() { }
    
    public PreferenceId(Preference preference) {
        this.entityId = new EntityId(preference.getEntity()).toString();
        this.name = preference.getName();
    }
    
    public boolean equals(Object o) {
        if (!(o instanceof PreferenceId)) {
            return false;
        }
        
        PreferenceId other = (PreferenceId)o;
        
        if (!getName().equals(other.getName())) {
            return false;
        }
        
        if (!getEntityId().equals(other.getEntityId())) {
            return false;
        }
        return true;
    }
    
    public int hashCode() {
        return getName().hashCode() ^ getEntityId().hashCode();
    }
    
    public String toString() {
        String s = getEntityId() + ":" + getName();
        return s;
    }    

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEntityId() {
        return entityId;
    }

    public void setEntityId(String entityId) {
        this.entityId = entityId;
    }
}
