package com.sun.portal.pom;

import java.io.File;
import java.io.FileInputStream;
import javax.xml.XMLConstants;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public abstract class PomTest extends TestCase {
    public PomTest( String testName ) {
        super( testName );
    }
    
    public static Test suite() {
        return new TestSuite( PomTest.class );
    }
    
    protected Pom unmarshalPom() throws Exception {
        try {
            JAXBContext jc = JAXBContext.newInstance(Pom.class);
            Unmarshaller u = jc.createUnmarshaller();

            // see jaxp issue #18
            /*
            File schemaFile = new File("target/schema/pml_1_0.xsd");
            SchemaFactory sf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
            Schema schema = sf.newSchema(schemaFile);
            u.setSchema(schema);
            */
            
            Pom pom = (Pom)u.unmarshal(new FileInputStream( "src/test/resources/pml.xml" ) );
            
            return pom;
        } catch (Exception e) {
            e.printStackTrace();
            fail(e.getMessage());
            throw e;
        }
    }
    
    protected void marshalPom(Pom pom) throws Exception {
        JAXBContext jc = JAXBContext.newInstance(Pom.class);
        Unmarshaller u = jc.createUnmarshaller();
        
        Marshaller m = jc.createMarshaller();
        m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
        m.marshal(pom, System.err );
    }
}
